"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isPromiseLike(v) {
    return (v &&
        (typeof v === 'object' || typeof v === 'function') &&
        typeof v.then === 'function');
}
function withContext(ctx, fn) {
    return isPromiseLike(ctx)
        ? Promise.resolve(ctx).then(function (ctx) { return withContext(ctx, fn); })
        : typeof ctx === 'function' ? ctx(fn) : fn(ctx);
}
exports.default = withContext;
//# sourceMappingURL=Ctx.js.map