import OptimisticValueStore, { PendingOptimisticValue } from './OptimisticValueStore';
import { BaseCache, OptimisticUpdateHandler } from './optimistic';
import MutationID from '../types/MutationID';
declare class Mutation {
    readonly mutation: {
        id: MutationID;
        method: string;
        args: any;
    };
    private readonly _structuredMutation;
    private _optimisticUpdateHandler;
    private _optimisticValuesRequired;
    private _optimisticValuesSuplied;
    private _optimisticValueStore;
    private _pending;
    private _rejected;
    private readonly _result;
    private _resolve;
    private _reject;
    constructor(method: string, args: any, optimisticUpdate: void | OptimisticUpdateHandler, optimisticValueStore: OptimisticValueStore);
    _getOptimisticValue: (name: string) => PendingOptimisticValue;
    updateStatus(): void;
    isPending(): boolean;
    isRejected(): boolean;
    isBlocked(): boolean;
    applyOptimistic(cache: BaseCache): void;
    getResult(): Promise<any>;
    resolve(result: any): void;
    reject(err: Error): void;
}
export default Mutation;
