import Cache from '../types/Cache';
import NodeID from '../types/NodeID';
import { PendingOptimisticValue } from './OptimisticValueStore';
export declare type GetOptimisticValue = (name: string) => PendingOptimisticValue;
export declare class BaseCache {
    readonly id: NodeID;
    private readonly _data;
    private readonly _cache;
    private _resultData;
    private readonly _resultCache;
    constructor(id: NodeID, cache: Cache, resultCache: Cache);
    get(name: string, args?: any): void | any;
    set(name: string, args?: any, value?: any): this;
    getObject(typeName: string, id: string): BaseCache;
}
export declare type OptimisticUpdateHandler = (mutation: {
    objectName: string;
    methodName: string;
    args: any;
}, cache: BaseCache, getOptimisticValue: GetOptimisticValue) => any;
