import Cache, { CacheUpdate } from '../types/Cache';
import NetworkLayerInterface from '../types/NetworkLayerInterface';
import Query from '../types/Query';
import Mutation from './mutation';
import ServerPreparation from '../types/ServerPreparation';
export interface Handlers {
    _handleNetworkError: (err: Error) => any;
    _handleMutationError: (err: Error) => any;
    _handleNewSession: (data: Cache) => any;
    _handleUpdate: (data: void | CacheUpdate) => any;
    _handleQueueRequest: () => any;
    _handleSuccessfulResponse: (pendingMutations: number) => any;
}
declare class RequestBatcher {
    private _networkLayer;
    private _handlers;
    private _session;
    private _pendingMutations;
    private _localQuery;
    private _status;
    constructor(networkLayer: NetworkLayerInterface, serverPreparation: ServerPreparation | void, handlers: Handlers);
    updateQuery(query: Query): void;
    runMutation(mutation: Mutation): Promise<any>;
    getPendingMutations(): Array<Mutation>;
    private _request();
    private _queueRequest();
    private _fireRequest(localQuery, mutations);
    private _handleMutationResults(mutations, mutationResults, keepResolvedMutations?);
}
export default RequestBatcher;
