"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cuid = require("cuid");
var Ctx_1 = require("./Ctx");
var ServerResponse_1 = require("./types/ServerResponse");
var merge_queries_1 = require("./utils/merge-queries");
var diff_cache_1 = require("./utils/diff-cache");
var get_session_id_1 = require("./utils/get-session-id");
var runner_1 = require("./runner");
function handleMessage(schema, logging, sessionStore, message, context, mutationContext) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var query_1, _a, sessionID_1, cache_1, sessionID;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!(message.k === 1 /* NEW_SESSION */)) return [3 /*break*/, 2];
                    query_1 = message.q;
                    return [4 /*yield*/, Promise.all([
                            get_session_id_1.default(sessionStore),
                            Ctx_1.default(context(), function (queryContext) {
                                return runner_1.runQuery(query_1, { schema: schema, logging: logging, context: queryContext });
                            }),
                        ])];
                case 1:
                    _a = _b.sent(), sessionID_1 = _a[0], cache_1 = _a[1];
                    return [2 /*return*/, sessionStore.tx(sessionID_1, function (session) { return __awaiter(_this, void 0, void 0, function () {
                            var version;
                            return __generator(this, function (_a) {
                                version = cuid();
                                return [2 /*return*/, {
                                        session: {
                                            versions: [
                                                {
                                                    version: version,
                                                    query: query_1,
                                                    cache: cache_1,
                                                },
                                            ],
                                            mutations: {},
                                        },
                                        result: ServerResponse_1.createNewSessionResponse(sessionID_1, version, cache_1),
                                    }];
                            });
                        }); })];
                case 2:
                    sessionID = message.s;
                    return [2 /*return*/, sessionStore.tx(sessionID, function (session) { return __awaiter(_this, void 0, void 0, function () {
                            var _this = this;
                            var mutations, mutationResults, m_1, cache_2, version_1, states, state, query, cache, versions, cacheUpdate, version;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        mutations = {};
                                        mutationResults = [];
                                        if (!(message.m && message.m.length)) return [3 /*break*/, 2];
                                        m_1 = message.m;
                                        return [4 /*yield*/, Ctx_1.default((mutationContext || context)(), function (context) { return __awaiter(_this, void 0, void 0, function () {
                                                var i, result, _a;
                                                return __generator(this, function (_b) {
                                                    switch (_b.label) {
                                                        case 0:
                                                            i = 0;
                                                            _b.label = 1;
                                                        case 1:
                                                            if (!(i < m_1.length)) return [3 /*break*/, 5];
                                                            _a = (session && session.mutations[m_1[i].i]);
                                                            if (_a) return [3 /*break*/, 3];
                                                            return [4 /*yield*/, runner_1.runMutation({ method: m_1[i].m, args: m_1[i].a }, { schema: schema, logging: logging, context: context })];
                                                        case 2:
                                                            _a = (_b.sent());
                                                            _b.label = 3;
                                                        case 3:
                                                            result = _a;
                                                            mutations[m_1[i].i] = result;
                                                            mutationResults.push(result);
                                                            _b.label = 4;
                                                        case 4:
                                                            i++;
                                                            return [3 /*break*/, 1];
                                                        case 5: return [2 /*return*/];
                                                    }
                                                });
                                            }); })];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2:
                                        if (!session) {
                                            return [2 /*return*/, {
                                                    session: {
                                                        versions: [],
                                                        mutations: mutations,
                                                    },
                                                    result: ServerResponse_1.createExpiredSessionResponse(mutationResults),
                                                }];
                                        }
                                        if (!(message.k === 3 /* RESTORE_SESSION */)) return [3 /*break*/, 4];
                                        return [4 /*yield*/, Ctx_1.default(context(), function (queryContext) {
                                                return runner_1.runQuery(query, { schema: schema, logging: logging, context: queryContext });
                                            })];
                                    case 3:
                                        cache_2 = _a.sent();
                                        version_1 = cuid();
                                        return [2 /*return*/, {
                                                session: {
                                                    versions: [
                                                        {
                                                            version: version_1,
                                                            query: message.q,
                                                            cache: cache_2,
                                                        },
                                                    ],
                                                    mutations: mutations,
                                                },
                                                result: ServerResponse_1.createRestoreResponse(version_1, cache_2, mutationResults),
                                            }];
                                    case 4:
                                        states = session.versions.filter(function (v) { return v.version === message.v; });
                                        if (!states.length) {
                                            return [2 /*return*/, {
                                                    session: {
                                                        versions: session.versions,
                                                        mutations: mutations,
                                                    },
                                                    result: ServerResponse_1.createExpiredSessionResponse(mutationResults),
                                                }];
                                        }
                                        state = states[0];
                                        query = message.q
                                            ? merge_queries_1.default(state.query, message.q)
                                            : state.query;
                                        return [4 /*yield*/, Ctx_1.default(context(), function (queryContext) {
                                                return runner_1.runQuery(query, { schema: schema, logging: logging, context: queryContext });
                                            })];
                                    case 5:
                                        cache = _a.sent();
                                        versions = session.versions.filter(function (s) { return s.version >= message.v; });
                                        cacheUpdate = diff_cache_1.default(state.cache, cache);
                                        version = message.v;
                                        if (cacheUpdate || message.q) {
                                            version = cuid();
                                            versions.push({ version: version, query: query, cache: cache });
                                        }
                                        return [2 /*return*/, {
                                                session: {
                                                    versions: versions,
                                                    mutations: mutations,
                                                },
                                                result: ServerResponse_1.createUpdateResponse(version, cacheUpdate, mutationResults),
                                            }];
                                }
                            });
                        }); })];
            }
        });
    });
}
exports.default = handleMessage;
//# sourceMappingURL=handleMessage.js.map