"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get_type_1 = require("./get-type");
var ta = require("./TypeAssertions");
function normalizeField(field, fieldName, typeName, typeNames) {
    var ctx = typeName + '.' + fieldName;
    var f = ta.String.or(ta.ObjectKeys(['type', 'description', 'args', 'auth', 'resolve'])).validate(field, ctx);
    if (typeof f === 'string') {
        return {
            kind: "FieldProperty" /* FieldProperty */,
            name: typeName,
            description: undefined,
            resultType: get_type_1.default(f, ctx, typeNames),
            auth: 'public',
        };
    }
    var resolve = ta.Void.or(ta.Fn).validate(f.resolve, ctx + '.resolve');
    if (resolve) {
        return {
            kind: "FieldMethod" /* FieldMethod */,
            name: typeName,
            description: ta.Void.or(ta.String).validate(f.description, ctx + '.description'),
            resultType: get_type_1.default(f.type, ctx + '.type', typeNames),
            argType: get_type_1.default(f.args === undefined ? 'void' : f.args, ctx + '.args', typeNames),
            auth: ta
                .Literal('public')
                .or(ta.Fn)
                .validate(f.auth === undefined ? 'public' : f.auth, ctx + '.auth'),
            resolve: resolve,
        };
    }
    return {
        kind: "FieldProperty" /* FieldProperty */,
        name: typeName,
        description: ta.Void.or(ta.String).validate(f.description, ctx + '.description'),
        resultType: get_type_1.default(f.type, ctx + '.type', typeNames),
        auth: ta
            .Literal('public')
            .or(ta.Fn)
            .validate(f.auth === undefined ? 'public' : f.auth, ctx + '.auth'),
    };
}
exports.default = normalizeField;
//# sourceMappingURL=normalize-field.js.map