"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require("assert");
var normalize_field_1 = require("./normalize-field");
var ta = require("./TypeAssertions");
function normalizeFields(fields, typeName, typeNames) {
    var result = {};
    var f = ta.AnyObject.validate(fields, typeName + '.fields');
    Object.keys(f).forEach(function (fieldName) {
        var field = f[fieldName];
        if (field === undefined)
            return;
        assert(/^[A-Za-z0-9]+$/.test(fieldName), "Expected " + typeName + "'s field names to match [A-Za-z0-9]+ but got '" + fieldName + "'");
        result[fieldName] = normalize_field_1.default(field, fieldName, typeName, typeNames);
    });
    return result;
}
exports.default = normalizeFields;
//# sourceMappingURL=normalize-fields.js.map