"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get_type_1 = require("./get-type");
var ta = require("./TypeAssertions");
function normalizeMutation(mutation, typeName, mutationName, typeNames) {
    var ctx = typeName + '.' + mutationName;
    var m = ta
        .ObjectKeys(['type', 'description', 'args', 'resolve', 'auth'])
        .validate(mutation, ctx);
    return {
        kind: "Mutation" /* Mutation */,
        name: mutationName,
        description: ta.Void.or(ta.String).validate(m.description, ctx + '.description'),
        argType: get_type_1.default(m.args === undefined ? 'void' : m.args, ctx + '.args', typeNames),
        resultType: get_type_1.default(m.type === undefined ? 'void' : m.type, ctx + '.type', typeNames),
        auth: ta
            .Literal('public')
            .or(ta.Fn)
            .validate(m.auth === undefined ? 'public' : m.auth, ctx + '.auth'),
        resolve: ta.Fn.validate(m.resolve, ctx + '.resolve'),
    };
}
exports.default = normalizeMutation;
//# sourceMappingURL=normalize-mutation.js.map