"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var body_parser_1 = require("body-parser");
var handleMessage_1 = require("./handleMessage");
var jsonBody = body_parser_1.json();
function createBicycleMiddleware(schema, logging, sessionStore, getContext) {
    var processRequest = function (req, res, next) {
        handleMessage_1.default(schema, logging, sessionStore, req.body, function () { return getContext(req, res, { stage: 'query' }); }, function () { return getContext(req, res, { stage: 'mutation' }); }).then(function (response) { return res.json(response); }, function (err) { return next(err); });
    };
    return function (req, res, next) {
        if (req.method !== 'POST')
            return next();
        if (!req.body) {
            jsonBody(req, res, function (err) {
                if (err)
                    return next(err);
                processRequest(req, res, next);
            });
        }
        else {
            processRequest(req, res, next);
        }
    };
}
exports.default = createBicycleMiddleware;
//# sourceMappingURL=middleware.js.map