/// <reference types="express" />
import { Request, Response } from 'express';
import { QueryCacheResult } from './utils/run-query-against-cache';
import SessionStore from './sessions/SessionStore';
import Cache from './types/Cache';
import Logging from './types/Logging';
import Query from './types/Query';
import Schema from './types/Schema';
import SessionID from './types/SessionID';
import ServerPreparation from './types/ServerPreparation';
import { BaseRootQuery } from './typed-helpers/query';
import { Ctx } from './Ctx';
export declare class FakeClient {
    _sessionID: SessionID;
    _query: Query;
    _cache: Cache;
    constructor(sessionID: SessionID);
    queryCache<TResult>(query: BaseRootQuery<TResult>): QueryCacheResult<TResult>;
    queryCache(query: Query): QueryCacheResult<any>;
    update(): void;
    subscribe(): void;
}
export default function prepare<Context, TResult>(schema: Schema<Context>, logging: Logging, sessionStore: SessionStore, getContext: (req: Request, res: Response, options: {
    stage: 'query' | 'mutation';
}) => Ctx<Context>, fn: (client: FakeClient, req: Request, res: Response, ...args: any[]) => TResult): (req: Request, res: Response, ...args: any[]) => Promise<{
    serverPreparation: ServerPreparation;
    result: TResult;
}>;
