import ErrorResult from './ErrorResult';
import NodeID from './NodeID';
export declare type CacheDataPrimative = void | null | string | number | boolean | ErrorResult;
export declare type CacheDataBase = CacheDataPrimative | NodeID | CacheObject;
export declare type CacheUpdateDataBase = CacheDataPrimative | NodeID | CacheUpdateObject;
export declare type CacheData = CacheDataBase | (CacheDataBase | any[])[];
export declare type CacheUpdateData = CacheUpdateDataBase | (CacheDataBase | any[])[];
export interface CacheUpdateObject {
    [name: string]: CacheUpdateData;
}
export interface CacheObject extends CacheUpdateObject {
    [name: string]: CacheData;
}
export interface NodeCache extends NodeCacheUpdate {
    [id: string]: void | CacheObject;
}
interface Cache extends CacheUpdate {
    [nodeName: string]: void | NodeCache;
}
export default Cache;
export interface NodeCacheUpdate {
    [id: string]: void | CacheUpdateObject;
}
export interface CacheUpdate {
    [nodeName: string]: void | NodeCacheUpdate;
}
export declare function isCacheObject(cache: CacheData): cache is CacheObject;
export declare function isCacheObject(cache: CacheUpdateData): cache is CacheUpdateObject;
