import Mutation from '../client/mutation';
import MutationID from './MutationID';
import SessionID from './SessionID';
import SessionVersion from './SessionVersion';
import Query, { QueryUpdate } from './Query';
export declare const enum RequestKind {
    NEW_SESSION = 1,
    UPDATE = 2,
    RESTORE_SESSION = 3,
}
export interface NewSession {
    readonly k: RequestKind.NEW_SESSION;
    readonly q: Query;
}
export interface Update {
    readonly k: RequestKind.UPDATE;
    readonly s: SessionID;
    readonly v: SessionVersion;
    readonly q: void | QueryUpdate;
    readonly m: void | {
        m: string;
        a: any;
        i: MutationID;
    }[];
}
export interface RestoreSession {
    readonly k: RequestKind.RESTORE_SESSION;
    readonly s: SessionID;
    readonly q: Query;
    readonly m: void | {
        m: string;
        a: any;
        i: MutationID;
    }[];
}
declare type Request = NewSession | Update | RestoreSession;
export default Request;
export declare function createNewSessionRequest(query: Query): Request;
export declare function createUpdateRequest(sessionID: SessionID, version: SessionVersion, query: void | QueryUpdate, mutations: void | Mutation[]): Request;
export declare function createRestoreRequest(sessionID: SessionID, query: Query, mutations: void | Mutation[]): Request;
