"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RequestKind;
(function (RequestKind) {
    RequestKind[RequestKind["NEW_SESSION"] = 1] = "NEW_SESSION";
    RequestKind[RequestKind["UPDATE"] = 2] = "UPDATE";
    RequestKind[RequestKind["RESTORE_SESSION"] = 3] = "RESTORE_SESSION";
})(RequestKind = exports.RequestKind || (exports.RequestKind = {}));
function createNewSessionRequest(query) {
    return {
        k: 1 /* NEW_SESSION */,
        q: query,
    };
}
exports.createNewSessionRequest = createNewSessionRequest;
function createUpdateRequest(sessionID, version, query, mutations) {
    return {
        k: 2 /* UPDATE */,
        s: sessionID,
        v: version,
        q: query,
        m: mutations
            ? mutations.map(function (_a) {
                var _b = _a.mutation, method = _b.method, args = _b.args, id = _b.id;
                return ({
                    m: method,
                    a: args,
                    i: id,
                });
            })
            : undefined,
    };
}
exports.createUpdateRequest = createUpdateRequest;
function createRestoreRequest(sessionID, query, mutations) {
    return {
        k: 3 /* RESTORE_SESSION */,
        s: sessionID,
        q: query,
        m: mutations
            ? mutations.map(function (_a) {
                var _b = _a.mutation, method = _b.method, args = _b.args, id = _b.id;
                return ({
                    m: method,
                    a: args,
                    i: id,
                });
            })
            : undefined,
    };
}
exports.createRestoreRequest = createRestoreRequest;
//# sourceMappingURL=Request.js.map