"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ServerResponseKind;
(function (ServerResponseKind) {
    ServerResponseKind[ServerResponseKind["EXPIRED"] = 0] = "EXPIRED";
    ServerResponseKind[ServerResponseKind["NEW_SESSION"] = 1] = "NEW_SESSION";
    ServerResponseKind[ServerResponseKind["UPDATE"] = 2] = "UPDATE";
    ServerResponseKind[ServerResponseKind["RESTORE"] = 3] = "RESTORE";
})(ServerResponseKind = exports.ServerResponseKind || (exports.ServerResponseKind = {}));
function createExpiredSessionResponse(mutationResults) {
    return {
        k: 0 /* EXPIRED */,
        m: mutationResults,
    };
}
exports.createExpiredSessionResponse = createExpiredSessionResponse;
function createNewSessionResponse(sessionID, version, data) {
    return {
        k: 1 /* NEW_SESSION */,
        s: sessionID,
        v: version,
        d: data,
    };
}
exports.createNewSessionResponse = createNewSessionResponse;
function createUpdateResponse(version, data, mutationResults) {
    return {
        k: 2 /* UPDATE */,
        v: version,
        d: data,
        m: mutationResults,
    };
}
exports.createUpdateResponse = createUpdateResponse;
function createRestoreResponse(version, data, mutationResults) {
    return {
        k: 3 /* RESTORE */,
        v: version,
        d: data,
        m: mutationResults,
    };
}
exports.createRestoreResponse = createRestoreResponse;
//# sourceMappingURL=ServerResponse.js.map