"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function diffQueries(oldQuery, newQuery) {
    var result = undefined;
    Object.keys(oldQuery).forEach(function (key) {
        if (key[0] === '_')
            return;
        if (oldQuery[key] && !newQuery[key]) {
            if (!result)
                result = {};
            result[key] = false;
        }
    });
    Object.keys(newQuery).forEach(function (key) {
        if (key[0] === '_')
            return;
        var oldV = oldQuery[key];
        var newV = newQuery[key];
        if (!oldV) {
            if (!result)
                result = {};
            result[key] = newV;
        }
        else if (typeof oldV !== typeof newV) {
            if (!result)
                result = {};
            result[key] = newV;
        }
        else if (oldV !== newV &&
            typeof oldV === 'object' &&
            typeof newV === 'object') {
            var d = diffQueries(oldV, newV);
            if (d !== undefined) {
                if (!result)
                    result = {};
                result[key] = d;
            }
        }
    });
    return result;
}
exports.default = diffQueries;
//# sourceMappingURL=diff-queries.js.map