"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Cache_1 = require("../types/Cache");
var ErrorResult_1 = require("../types/ErrorResult");
var EMPTY_OBJECT = {};
function mergeCacheObject(cache, update) {
    var result = {};
    if (cache !== EMPTY_OBJECT) {
        Object.keys(cache).forEach(function (key) {
            result[key] = cache[key];
        });
    }
    Object.keys(update).forEach(function (key) {
        var c = cache[key];
        var u = update[key];
        if (ErrorResult_1.isErrorResult(u)) {
            result[key] = u;
        }
        else if (Cache_1.isCacheObject(u)) {
            if (Cache_1.isCacheObject(c)) {
                result[key] = mergeCacheObject(c, u);
            }
            else {
                result[key] = mergeCacheObject(EMPTY_OBJECT, u);
            }
        }
        else {
            result[key] = u;
        }
    });
    return result;
}
function mergeNodeCache(cache, update) {
    var result = {};
    if (cache !== EMPTY_OBJECT) {
        Object.keys(cache).forEach(function (key) {
            result[key] = cache[key];
        });
    }
    Object.keys(update).forEach(function (id) {
        var v = update[id];
        if (v) {
            result[id] = mergeCacheObject(cache[id] || EMPTY_OBJECT, v);
        }
    });
    return result;
}
function mergeCache(cache, update) {
    var result = {};
    Object.keys(cache).forEach(function (key) {
        result[key] = cache[key];
    });
    Object.keys(update).forEach(function (typeName) {
        var v = update[typeName];
        if (v) {
            result[typeName] = mergeNodeCache(cache[typeName] || EMPTY_OBJECT, v);
        }
    });
    return result;
}
exports.default = mergeCache;
//# sourceMappingURL=merge-cache.js.map