"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function mergeQueries() {
    var queries = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        queries[_i] = arguments[_i];
    }
    var result = {};
    var _loop_1 = function (query) {
        Object.keys(query).forEach(function (key) {
            if (key[0] === '_')
                return;
            var resultKey = key.replace(/ as [a-zA-Z0-9]+$/, '');
            var q = query[key];
            if (q === false) {
                if (resultKey in result)
                    delete result[resultKey];
            }
            else if (q === true) {
                result[resultKey] = query[key];
            }
            else if (q && typeof q === 'object') {
                result[resultKey] = mergeQueries(result[resultKey] || {}, q);
            }
            else {
                if (process.env.NODE_ENV !== 'production') {
                    throw new Error('Invalid type in query ' +
                        require('util').inspect(query) +
                        ', queries should match `{[key: string]: boolean}`');
                }
                throw new Error('Invalid type in query ' +
                    query +
                    ', queries should match `{[key: string]: boolean}`');
            }
        });
    };
    for (var _a = 0, queries_1 = queries; _a < queries_1.length; _a++) {
        var query = queries_1[_a];
        _loop_1(query);
    }
    return result;
}
exports.default = mergeQueries;
//# sourceMappingURL=merge-queries.js.map