"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function notEqual(oldValue, newValue) {
    if (oldValue === newValue)
        return false;
    return (Object.keys(oldValue).some(function (key) {
        var oldProp = oldValue[key];
        var newProp = newValue[key];
        if (oldProp === newProp)
            return false;
        if (oldProp && newProp) {
            if (Array.isArray(oldProp) &&
                Array.isArray(newProp) &&
                oldProp.length === newProp.length) {
                return oldProp.some(function (val, i) {
                    if (val === newProp[i])
                        return false;
                    if (val &&
                        newProp[i] &&
                        typeof val === 'object' &&
                        typeof newProp[i] === 'object') {
                        return notEqual(val, newProp[i]);
                    }
                    return true;
                });
            }
            if (!Array.isArray(oldProp) &&
                typeof oldProp === 'object' &&
                typeof newProp === 'object') {
                return notEqual(oldProp, newProp);
            }
        }
        return true;
    }) || Object.keys(newValue).some(function (key) { return !(key in oldValue); }));
}
exports.default = notEqual;
//# sourceMappingURL=not-equal.js.map