"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var leven = require("leven");
/**
 * Find the closest match for a string in a list of valid strings.  This can be used to suggest corrections for typos.
 */
function suggestMatch(validKeys, key) {
    if (process.env.NODE_ENV === 'production')
        return '';
    var closestMatch = validKeys.reduce(function (best, validKey) {
        var distance = leven(key, validKey);
        return distance < best.distance ? { distance: distance, validKey: validKey } : best;
    }, { distance: Infinity, validKey: '' });
    return closestMatch.distance < key.length / 2
        ? " maybe you meant to use \"" + closestMatch.validKey + "\""
        : "";
}
exports.default = suggestMatch;
//# sourceMappingURL=suggest-match.js.map